{k tomuto patri soubory v45.pas a project1.dpr, ketry se mi
nepodarilo prejmenovat na v45.dpr, aby fungoval}

{pri spusteni musite zadat parametr jmena souboru s bludistem}

{testoval jsem to na souboru blud.bld}

{nevim proc, ale uz dvakrat mi to psalo Out Of System Resources a musel jsem restartovat Windows 95}

unit V45;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, Buttons,
  StdCtrls, ExtCtrls;

type

  TForm1 = class(TForm)
    Memo1: TMemo; {sem si ukladam bludiste ve forme textu}
    SpeedButton1: TSpeedButton;
    Timer1: TTimer;
    Button1: TButton;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure MyKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Pole : array [1..40, 1..20] of TBitBtn; {Hraci plocha}
  end;

var
  Form1: TForm1;
    X, Y : Byte; {Rozmery pole X-sirka  Y-vyska}
    sirka, vyska: real;  {puvodni sirka a vyska formulare}
    Bludiste: string;  {nazev souboru s bludistem}
    zivoty:word; {pocet zivotu}
    skore:word;  {skore hrace}

implementation

{$R *.DFM}

procedure TForm1.MyKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  {}
end;

procedure TForm1.FormCreate(Sender: TObject);
var i:integer;

procedure TestujParametry; {otestuju parametry}
begin
  if paramcount=1 then Bludiste := paramstr(1)
  else close;
end;

procedure rozmery; {uchovani puvodnich rozmeru}
const a:byte=0;
begin
  if a=0 then begin
    sirka:=form1.width;
    vyska:=form1.height;
    a:=1;
  end;
end;


procedure Nacti;    {nactu bludistre do mema}
var pom:byte;
    s:string;
begin
  Memo1.Visible:=false;
  pom:=0;
  try       {osetreni spatneho jmena souboru, ale nefunguje to}
    Memo1.Lines.LoadFromFile(Bludiste);
  except
    on EFOpenError do close;
  end;
  X:= Length(memo1.Lines[0]);   {sirka bludiste}
  repeat
    s:=memo1.lines[pom];
    inc(pom);
  until s='';
  Y:=pom-1;  {vyska bludiste}
end;

procedure VytvorPole; {Vytvori pole na obrazovce}
var I, J : integer;
begin
  for I := 1 to X do
    for J := 1 to Y do
      begin
        Pole[I, J] := TBitBtn.Create(Self);
        Pole[I, J].Width := 15;
        Pole[I, J].Height := 15;
        Pole[I, J].Top := J*16-15;
        Pole[I, J].Left := I*16-15;
        Pole[I, J].OnKeyDown := Form1.MyKeyDown;
        InsertControl(Pole[I, J]);
      end;
end;

procedure zobraz; {zobrazi ikony}
var I, J:integer;
    s,s1:string;
    c:char;
    pom:byte;
begin
  for i:=1 to Y-1 do begin  {tady to nefunguje, melo by to byt do Y}
    S:=memo1.Lines[i-1];
    for j:=1 to X do begin
      c:=s[j];

      case c of
        '1'..'9': Pole[J,I].Glyph.LoadFromFile('pris_l.bmp');
      end;
      case ord(c) of
        46:begin
             pom:=random(3)+1;
             s1:=inttostr(pom);
             Pole[J,I].Glyph.LoadFromFile('jidlo'+s1+'.bmp');
           end;
        42:Pole[J,I].Glyph.LoadFromFile('hrac_l.bmp');
        64:Pole[J,I].Glyph.LoadFromFile('pris_l.bmp');
        35:Pole[J,I].Glyph.LoadFromFile('zed.bmp');
      end;
    end;
    end;
end;

begin
  Zivoty:=3;
  Skore:=0;
  TestujParametry;
  Rozmery;
  Randomize;
  Nacti;
  VytvorPole;
  Zobraz;
end;

procedure TForm1.FormDestroy(Sender: TObject);
var I, J : Integer;
begin
  for I:=1 to 40 do
    for J:=1 to 20 do
      Pole[I,J].Free;
end;

procedure TForm1.FormResize(Sender: TObject); {zmeni velikosti ostatnich objektu na obrazovce}
var i:integer;
begin
  for i:=0 to controlcount-1 do begin
    controls[i].width:=round(form1.width*controls[i].width/sirka);
    controls[i].height:=round(form1.height*controls[i].height/vyska);
    controls[i].top:=round(form1.width*controls[i].top/sirka);
    controls[i].left:=round(form1.height*controls[i].left/vyska);
  end;
end;

procedure TForm1.Button1Click(Sender: TObject); {Pauza ci ne}
begin
   Timer1.Enabled:=not(Timer1.Enabled);
end;

end.
